SystemOrganization addCategory: 'OrbeonBizagiSvgConverter'!

!XPDLEndNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/10/2016 08:22'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas drawEndNamed: self getName at: self getXcoordinate @ self getYcoordinate! !

JASVGICanvas subclass: #JASVGIBpmCanvas
	instanceVariableNames: 'namesAndTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiSvgConverter'!

!JASVGIBpmCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 12:22'!
defaultNameForProcessGroup

	^'process'! !

!JASVGIBpmCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 06:38'!
example1
	| jasv line |

	jasv := JASVGIBpmCanvas newWidth: '400px' height: '400px'.
	jasv addMarker: 
		(JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	jasv drawStartNamed: 'start' at: 30@30.
	jasv drawActivityNamed: 'Task 1' at: 200@30.
	jasv drawActivityNamed: 'Task 2' at: 60@90.
	jasv drawEndNamed: 'end' at: 300@300.

	line := jasv connect: (jasv getJasvgiTagNamed: 'start') to:  (jasv getJasvgiTagNamed: 'Task 1').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'start') to:  (jasv getJasvgiTagNamed: 'Task 2').
	line setMarkerEnd: 'arrow'.

	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 1') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 2') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.

	jasv contents.! !

!JASVGIBpmCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 07:05'!
example2
	| jasv line |

	jasv := JASVGIBpmCanvas newWidth: '500px' height: '400px'.
	jasv addMarker: 
		(JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	jasv drawStartNamed: 'start' at: 30@30.
	jasv drawActivityNamed: 'Task 1' at: 80@30.
	jasv drawGatewayAt: 250@45 id: 'g1'.
	jasv drawActivityNamed: 'Task 2' at: 320@30.
	jasv drawActivityNamed: 'Task 3' at: 100@150.
	jasv drawEndNamed: 'end' at: 290@180.

	line := jasv connect: (jasv getJasvgiTagNamed: 'start') to:  (jasv getJasvgiTagNamed: 'Task 1').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 1') to:  (jasv getJasvgiTagNamed: 'g1').
	line setMarkerEnd: 'arrow'.

	line := jasv connect: (jasv getJasvgiTagNamed: 'g1') to:  (jasv getJasvgiTagNamed: 'Task 2').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'g1') to:  (jasv getJasvgiTagNamed: 'Task 3').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 2') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 3') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.
	jasv contents.! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/11/2016 07:16'!
connect: figureOne to: figureTwo

	^self connect: figureOne to: figureTwo color: 'black'! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/11/2016 07:16'!
connect: figureOne to: figureTwo color: color

	^self connect: figureOne to: figureTwo color: color stroke: color widthPx: '1px'! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/11/2016 11:57'!
connect: figureOne to: figureTwo color: color stroke: stroke widthPx: widthPx
	| line |

	line := self drawLineFrom: (figureOne getPointToConnectTo: figureTwo) 
					to: (figureTwo getPointToConnectTo: figureOne) 
					id: UUID new asString
					widthPx: widthPx
					stroke: stroke 
					fillColor: color.

	self addFigure: line toGroup: self defaultNameForProcessGroup.

	^line! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/11/2016 07:15'!
connect: figureOne to: figureTwo color: color widthPx: widthPx

	^self connect: figureOne to: figureTwo color: color stroke: color widthPx: widthPx! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 14:06'!
connectWith: coordinates color: color widthPx: widthPx
	| path |

	path := self drawLineM: coordinates id: UUID new asString widthPx: widthPx stroke: color fillColor: 'none'.

	self addFigure: path toGroup: self defaultNameForProcessGroup.

	^path! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 14:22'!
connectWith: coordinates color: color widthPx: widthPx condition: condition
	| path text |

	path := self drawLineM: coordinates id: UUID new asString widthPx: widthPx stroke: color fillColor: 'none'.

	text := self drawText: condition at: coordinates first textSizePx: self defaultTransitionConditionSize.

	self addFigure: path toGroup: self defaultNameForProcessGroup.
	self addFigure: text toGroup: self defaultNameForProcessGroup.

	^path! !

!JASVGIBpmCanvas methodsFor: 'draw' stamp: 'BrunoBB 09/11/2016 12:58'!
contents
	
	svgTag with: [
		self tag: 'defs' with: [svgMarkers do: [:each | each drawOn: self]].
		(svgGroups orderedKeys select: [:e | e notNil]) do:[:key | | tagGroup |
			tagGroup := svgGroups at: key.
			tagGroup drawOn: self.
		].
		(svgFigures orderedKeys select: [:e | e notNil]) do:[:key | | svgFigureTag |
			svgFigureTag := svgFigures at: key.
			svgFigureTag drawOn: self.
		].
		(svgLines orderedKeys select: [:e | e notNil]) do:[:key | | svgLineTag |
			svgLineTag := svgLines at: key.
			svgLineTag drawOn: self.
		].
	].

	^xmlCanvas contents! !

!JASVGIBpmCanvas methodsFor: 'draw' stamp: 'BrunoBB 09/13/2016 03:57'!
createDefaultGroup
	| group |

	group := JASVGITagGroup newNamed: self defaultNameForProcessGroup.
	group transform: 'translate(0,50)'.

	^svgGroups at: self defaultNameForProcessGroup put: group! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/12/2016 14:24'!
defaultActivityNameSize

	^'14px'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:03'!
defaultEndEventFillColor

	^'red'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 08:20'!
defaultEventFillColor

	^'blue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:42'!
defaultEventHeight

	^40! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/12/2016 14:21'!
defaultEventNameSize

	^'12px'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:43'!
defaultEventWidth

	^40! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:42'!
defaultGatewayFillColor

	^'lightgray'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:43'!
defaultGatewayHeight

	^30! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/12/2016 14:22'!
defaultGatewayNameSize

	^'12px'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 07:08'!
defaultGatewayStroke

	^'darkred'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:43'!
defaultGatewayWidth

	^30! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/11/2016 08:09'!
defaultLaneColor

	^'none'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/11/2016 07:47'!
defaultLaneStroke

	^'black'! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/11/2016 12:22'!
defaultNameForProcessGroup

	^self class defaultNameForProcessGroup! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/11/2016 15:54'!
defaultStartEventFillColor

	^'lightgreen'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskFillColor

	^'lightsteelblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 08:47'!
defaultTaskHeight

	^40! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 08:47'!
defaultTaskWidth

	^100! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/12/2016 14:22'!
defaultTransitionConditionSize

	^'10px'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:04'!
defultEndEventStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 08:20'!
defultEventStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:42'!
defultStartEventStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 15:19'!
drawActivityNamed: aString at: aPoint

	^self drawActivityNamed: aString at: aPoint color: self defaultTaskFillColor! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 14:58'!
drawActivityNamed: aString at: aPoint color: color

	^self drawActivityNamed: aString at: aPoint color: color stroke: self defaultTaskStroke! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 10:16'!
drawActivityNamed: aString at: aPoint color: color stroke: stroke

	^self drawActivityNamed: aString at: aPoint extent: (self defaultTaskWidth @ self defaultTaskHeight) color: color stroke: stroke! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/13/2016 09:24'!
drawActivityNamed: aString at: aPoint extent: extentPoint

	^self drawActivityNamed: aString at: aPoint extent: (extentPoint x @ extentPoint y) color: self defaultTaskFillColor stroke: self defaultTaskStroke! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 14:24'!
drawActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke
	| rect textPoint |

	rect := self drawRoundRectangleAt: aPoint 
						height: extent y 
						width: extent x 
						fillColor: color
						stroke: stroke.

	textPoint := (aPoint x + 5) @ (aPoint y + 32).

	namesAndTags at: aString put: rect. "map the Activity name with the Activity id"

	self addFigure: rect toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: textPoint textSizePx: self defaultActivityNameSize) toGroup: self defaultNameForProcessGroup.

	^rect! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 14:21'!
drawEndNamed: aString at: aPoint
	| end textPoint |
	"aPoint + 15 >> to fix a mismatch with Bizagi coordinates"
	end := self drawCircleAt: aPoint + 15 r: 15 fillColor: self defaultEndEventFillColor stroke: self defultEndEventStroke strokeWidth: '3'.

	textPoint := (aPoint x + (self defaultEventWidth // 3)) @ (aPoint y + (self defaultEventHeight // 2)).

	namesAndTags at: aString put: end. "map the Activity name with the Activity id"

	self addFigure: end toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: end position textSizePx: self defaultEventNameSize) toGroup: self defaultNameForProcessGroup.

	^end! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 14:21'!
drawEventNamed: aString at: aPoint
	| event textPoint |
	"aPoint + 15 >> to fix a mismatch with Bizagi coordinates"
	event := self drawCircleAt: aPoint + 15 r: 15 fillColor: self defaultEventFillColor stroke: self defultEventStroke strokeWidth: '2'.
	event id: aString.

	textPoint := (aPoint x + (self defaultEventWidth // 3)) @ (aPoint y + (self defaultEventHeight // 2)).

	namesAndTags at: aString put: event. "map the Activity name with the Activity id"

	self addFigure: event toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: event position textSizePx: self defaultEventNameSize) toGroup: self defaultNameForProcessGroup.

	^event! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 08:23'!
drawGatewayAt: aPoint

	^self drawGatewayAt: aPoint id: UUID new asString! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/13/2016 10:10'!
drawGatewayAt: aPoint color: color

	^self drawGatewayAt: aPoint id: UUID new asString color: color! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/11/2016 11:52'!
drawGatewayAt: aPoint id: id

	^self drawGatewayAt: aPoint 
			id: id 
			height: self defaultGatewayHeight 
			width: self defaultGatewayWidth
			fillColor: self defaultGatewayFillColor
			stroke: self defaultGatewayStroke! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 08:45'!
drawGatewayAt: aPoint id: id color: color

	^self drawGatewayAt: aPoint 
			id: id 
			height: self defaultGatewayHeight 
			width: self defaultGatewayWidth
			fillColor: color
			stroke: self defaultGatewayStroke! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 14:21'!
drawGatewayAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke
	| figure rotation textPoint |
	"aPoint + 5 >> to fix a mismatch with Bizagi coordinates"
	figure := JASVGITagRectangle newAt: aPoint + 5 id: id height: height width: width fillColor: fillColor stroke: stroke.

	rotation := 'rotate(-45 ', figure center x printString, ' ', figure center y printString, ')'.
	figure transform: rotation.

	textPoint := aPoint x @ (aPoint y - 10).

	namesAndTags at: id put: figure. "map the Gateway name with the Gateway id"

	self draw: figure.

	self addFigure: figure toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: id at: textPoint textSizePx: self defaultGatewayNameSize) toGroup: self defaultNameForProcessGroup.

	^figure! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/11/2016 07:46'!
drawLaneNamed: aString at: aPoint width: width height: height

	^self drawLaneNamed: aString at: aPoint width: width height: height color: self defaultLaneColor stroke: self defaultLaneStroke! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 14:20'!
drawLaneNamed: aString at: aPoint width: width height: height color: color stroke: stroke
	| rect |

	rect := self drawRoundRectangleAt: aPoint 
						height: height 
						width: width 
						fillColor: color
						stroke: stroke.

	namesAndTags at: aString put: rect. "map the Activity name with the Activity id"

	self addFigure: rect toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: aPoint - 10 textSizePx: '14px') toGroup: self defaultNameForProcessGroup.

	^rect! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/12/2016 14:21'!
drawStartNamed: aString at: aPoint
	| start textPoint |
	"aPoint + 15 >> to fix a mismatch with Bizagi coordinates"
	start := self drawCircleAt: aPoint + 15 r: 15 fillColor: self defaultStartEventFillColor stroke: self defultStartEventStroke.

	textPoint := (aPoint x + (self defaultEventWidth // 3)) @ (aPoint y + (self defaultEventHeight // 2)).

	namesAndTags at: aString put: start. "map the Activity name with the Activity id"

	self addFigure: start toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: start position textSizePx: self defaultEventNameSize) toGroup: self defaultNameForProcessGroup.

	^start! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/06/2016 10:26'!
getJasvgiTagNamed: aString

	^self getJasvgiTagNamed: aString ifAbsent: [nil]! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 05:54'!
getJasvgiTagNamed: aString ifAbsent: aBlock

	^namesAndTags at: aString ifAbsent: aBlock! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 08:34'!
getMarkerNamed: aString

	^svgMarkers at: aString ifAbsent: [nil]! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 12:31'!
initialize

	super initialize.

	namesAndTags := Dictionary new.

	self createDefaultGroup.! !

!JASVGIBpmCanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 10:21'!
namesAndTags
	^namesAndTags! !

!JASVGIBpmCanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 10:21'!
namesAndTags: newValue
	namesAndTags := newValue! !

!XPDLLaneNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/11/2016 08:55'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas
		drawLaneNamed: self getName 
		at: self getXcoordinate @ self getYcoordinate 
		width: self getWidth
		height: self getHeight! !

!XPDLTransitionNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 09:27'!
drawOn: aJasvgiBpmCanvas
	| transition |

	transition := 
		aJasvgiBpmCanvas 
			connectWith: coordinates
			color: 'gray'
			widthPx: '1px'.

	transition setMarkerEnd: 'arrow'! !

!XPDLTransitionNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 09:17'!
drawOn: aJasvgiBpmCanvas color: color
	| transition |

	transition := 
		aJasvgiBpmCanvas 
			connectWith: coordinates
			color: color
			widthPx: '1px'.

	transition setMarkerEnd: 'arrow'! !

!XPDLObject2 methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/10/2016 08:23'!
drawOn: aJasvgiBpmCanvas! !

!XPDLObject2 methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 09:13'!
drawOn: aJasvgiBpmCanvas color: color! !

!XPDLObject2 methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 10:06'!
drawOn: aJasvgiBpmCanvas context: aBpmProcessInstance color: color stroke: stroke! !

!XPDLObject2 methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/10/2016 14:25'!
getColor

	^(((xmlSegment findElementNamed: 'NodeGraphicsInfo') attributeAt: 'FillColor') = '-2517356')
		ifTrue: ['lightblue'] 
		ifFalse: ['lightgray']! !

!XPDLGatewayNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 09:25'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas drawGatewayAt: self getXcoordinate @ self getYcoordinate id: self getName color: 'lightgray'! !

!XPDLGatewayNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 10:11'!
drawOn: aJasvgiBpmCanvas context: aBpmProcessInstance color: color stroke: stroke 

	^aJasvgiBpmCanvas
		drawGatewayAt: self getXcoordinate @ self getYcoordinate 
		id: self getName
		color: color! !

!XPDLStartNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/10/2016 08:22'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas drawStartNamed: self getName at: self getXcoordinate @ self getYcoordinate! !

!XPDLEventNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/10/2016 08:21'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas drawEventNamed: self getName at: self getXcoordinate @ self getYcoordinate! !

!XPDLEventNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 10:04'!
drawOn: aJasvgiBpmCanvas context: aBpmProcessInstance color: color stroke: stroke 

	^self drawOn: aJasvgiBpmCanvas! !

!XPDLActivityNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 09:22'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas
		drawActivityNamed: self getName 
		at: self getXcoordinate @ self getYcoordinate
		extent: self getWidth @ self getHeight! !

!XPDLActivityNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 09:56'!
drawOn: aJasvgiBpmCanvas context: aBpmProcessInstance color: color stroke: stroke 

	^aJasvgiBpmCanvas
		drawActivityNamed: self getName 
		at: self getXcoordinate @ self getYcoordinate
		extent: self getWidth @ self getHeight
		color: color
		stroke: stroke! !

Object subclass: #XpdlSvgConverter
	instanceVariableNames: 'xpdlString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiSvgConverter'!

XpdlSvgConverter subclass: #BizagiSvgConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiSvgConverter'!

!XpdlSvgConverter class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 07:33'!
convert: xpdlString

	^super new initialize
		xpdlString: xpdlString;
		yourself! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 09:28'!
generateSVG
	| xpdlReader svgCanvas |

	xpdlReader := XPDLReader2 for: 'convert' withString: xpdlString.
	svgCanvas := JASVGIBpmCanvas newWidth: '1000px' height: '1000px'.
	svgCanvas addMarker: (JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	xpdlReader getAllWorkflows do: [:eachWorkflow | 
		eachWorkflow parentLanes do: [:eachLaneNode | eachLaneNode drawOn: svgCanvas].
		eachWorkflow activities do: [:eachActivityNode | eachActivityNode drawOn: svgCanvas].
		eachWorkflow transitions do: [:eachTransition | eachTransition drawOn: svgCanvas].
	].
	xpdlReader getAllWorkflows do: [:eachWorkflow | | gatewayText yCoordinate text |
		yCoordinate := eachWorkflow getLaneMaxYCoordinate + 20.
		eachWorkflow getGatewayNodes do: [:gatewayNode | 
			(gatewayNode outTransitions select: [:each | each hasCondition]) do: [:trNode | 
				gatewayText := gatewayNode getName, ' - ', trNode startCondition.
				text := svgCanvas drawText: gatewayText at: 10 @ yCoordinate.
				svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
				yCoordinate := yCoordinate + 20.
			].
		].
	].
	^svgCanvas contents! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 10:03'!
generateSVGFor: aBpmUser assignment: aBpmTaskAssignment
	| xpdlReader svgCanvas |

	xpdlReader := XPDLReader2 for: 'convert' withString: xpdlString.
	svgCanvas := JASVGIBpmCanvas newWidth: '1000px' height: '1000px'.
	svgCanvas addMarker: (JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	svgCanvas drawText: (self getSVGTitleFor: aBpmTaskAssignment) at: 20@20 textSizePx: '14px'.

	xpdlReader getAllWorkflows do: [:eachWorkflow | 
		eachWorkflow parentLanes do: [:eachLaneNode | eachLaneNode drawOn: svgCanvas].
		eachWorkflow activities do: [:eachActivityNode | | color stroke |
			color := aBpmTaskAssignment process getColorForActivityNamed: eachActivityNode getName user: aBpmUser.
			stroke := aBpmTaskAssignment process getStrokeForActivityNamed: eachActivityNode getName user: aBpmUser.
			eachActivityNode drawOn: svgCanvas context: aBpmTaskAssignment process color: color stroke: stroke].
		eachWorkflow transitions do: [:eachTransition | | color | 
			color := aBpmTaskAssignment process getColorForTransition: eachTransition user: aBpmUser.
			eachTransition drawOn: svgCanvas color: color].
	].

	xpdlReader getAllWorkflows do: [:eachWorkflow | | gatewayText yCoordinate text |
		yCoordinate := eachWorkflow getLaneMaxYCoordinate + 20.
		eachWorkflow getGatewayNodes do: [:gatewayNode | 
			(gatewayNode outTransitions select: [:each | each hasCondition]) do: [:trNode | 
				gatewayText := gatewayNode getName, ' - ', trNode startCondition.
				text := svgCanvas drawText: gatewayText at: 10 @ yCoordinate.
				svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
				yCoordinate := yCoordinate + 20.
			].
		].
	].

	^svgCanvas contents! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'BrunoBB 09/12/2016 13:14'!
getSVGTitleFor: aBpmTaskAssignment

	^'#', aBpmTaskAssignment processId printString, 
		' | Process Name: ', aBpmTaskAssignment processName,
		' | User: ', aBpmTaskAssignment printUserName,
		' | State: ', aBpmTaskAssignment printProcessState,
		' | Creation: ', aBpmTaskAssignment printAssignmentDate! !

!XpdlSvgConverter methodsFor: 'Accessing' stamp: 'BrunoBB 09/10/2016 07:32'!
xpdlString
	^xpdlString! !

!XpdlSvgConverter methodsFor: 'Updating' stamp: 'BrunoBB 09/10/2016 07:32'!
xpdlString: newValue
	xpdlString := newValue! !
